import QtQuick 1.1
import com.nokia.meego 1.0

import "../../common"

WAPage {
    id: container
    
    property string inputPicture
    property string outputFilePath
    property int maximumSize
    property int minimumSize
    property bool avatar: true

    signal selected(string path)

    function getOutputPath() {

        var outputPath,
            outputFilename = outputFilePath

        if(outputFilename) {

            if(outputFilename.substring(outputFilename.lastIndexOf('.')+1) == "jpg") {
                outputPath = outputFilename;

            } else {

                //treat as dir, preserve filename

                var filename = inputPicture.substring(inputPicture.lastIndexOf('/'))

                if(outputFilename.charAt(outputFilename.length -1 )=='/') {
                    outputFilename = outputFilename.substring(0,outputFilename.length - 1)
                }

                outputPath = outputFilename + filename

            }

            consoleDebug("OUTPUT PATH: "+outputPath)
            return outputPath
        }

        consoleDebug("RESIZE OUTPUT FILE NOT SPECIFIED");
    }

    tools: ToolBarLayout {
            id: toolBar
            ToolIcon {
                platformIconId: "toolbar-back"
                onClicked: {
                pageStack.pop();
            }

        }
            ToolIcon {
                platformIconId: "toolbar-refresh4"
                onClicked: {
                    pinch.rotate()
            }
        }
        
            ToolIcon {
                    id: doneButton
                    platformIconId: "toolbar-done"
                    onClicked: {
                      var outputPath = getOutputPath()

                      transformPicture(inputPicture, outputPath, pinch.rectX, pinch.rectY, pinch.rectW, pinch.rectH, maximumSize, pinch.angle)
                      selected(outputPath)
                    }
            }
    }

    InteractionArea {
        id: pinch
        anchors.fill: parent
        anchors.topMargin: avatar?header.height:-appWindow.__statusBarHeight
        anchors.bottomMargin: avatar?0:-appWindow.platformToolBarHeight
        avatar: container.avatar
        source: inputPicture
        bucketMinSize: minimumSize
    }
    
    WAHeader{
        id: header
        title: qsTr("Change picture")
        anchors.top:parent.top
        width:parent.width
        height: 73
    }
}
